<template>
  <nav class="Nav">
    <p-PanelMenu v-model:expandedKeys="expandedKeys" :model="props.items">
      <template #item="{ item }">
        <router-link
          :to="item.to"
          :title="item.label ? t(item.label) : ''"
          :class="['Nav__Item', item.class]"
          exact-active-class="Nav__Item--active"
        >
          <span :class="['Nav__Icon', item.icon]"></span>
          <span class="Nav__ItemLabel">{{
            item.label ? t(item.label) : ''
          }}</span>
        </router-link>
      </template>
    </p-PanelMenu>
    <span class="Nav__Spacer" />
    <p-Menu :model="props.actions">
      <template #item="{ item }">
        <p-Button
          :key="item.class"
          :title="item.label ? t(item.label) : ''"
          :class="`Nav__Action p-button-text p-button-secondary ${item.class}`"
          @click="item.command"
        >
          <span :class="item.icon"></span>
          <span class="Nav__ItemLabel">{{
            item.label ? t(item.label) : ''
          }}</span>
        </p-Button>
      </template>
    </p-Menu>
  </nav>
</template>

<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import { onMounted, ref, watch } from 'vue'
import { useRoute } from 'vue-router'
import { MenuItem } from '@/components/bars/MenuItem'

type Props = {
  items?: MenuItem[]
  actions?: MenuItem[]
}

const props = withDefaults(defineProps<Props>(), {
  items: () => [],
  actions: () => [],
})

const route = useRoute()
const expandedKeys = ref<Record<string, true>>({})

function openRelativeToRoute() {
  expandedKeys.value = {}
  route.path.split('/').map((shard) => {
    if (shard) expandedKeys.value[shard] = true
  })
}

onMounted(openRelativeToRoute)
watch(() => route.path, openRelativeToRoute)

const { t } = useI18n()
</script>

<style lang="scss">
@use 'src/style/variables' as v;
@use 'src/style/mixins' as m;

.Nav {
  $root: &;

  @mixin item {
    position: relative;
    flex: 1 1;
    padding: v.$spacing;
    border: none;
    background-color: transparent;
    color: var(--text-color);
    font-weight: inherit;
    text-decoration: none;
    cursor: pointer;

    &:hover,
    &--active {
      border-radius: 0;
      background: var(--surface-200);
    }

    &:focus {
      box-shadow: none;
    }
  }

  display: flex;
  flex: 1 1;
  flex-direction: column;

  &--mini {
    #{$root}__Item {
      grid-template-columns: 1rem;
    }

    #{$root}__ItemLabel {
      display: none;
    }

    #{$root}__Action {
      &:deep(.p-button-label) {
        display: none;
      }
    }

    .p-panelmenu-panel:not(:hover),
    .p-panelmenu-panel:not(:focus) {
      .p-toggleable-content {
        display: none;
      }
    }

    .p-panelmenu-panel:hover,
    .p-panelmenu-panel:focus {
      .p-toggleable-content {
        position: absolute;
        left: 3rem;
        z-index: 100;
        display: grid;
        overflow: hidden;
        border-left: 1px solid var(--surface-0);
        border-top-right-radius: v.$borderRadius;
        border-bottom-right-radius: v.$borderRadius;
        background-color: var(--surface-100);

        #{$root}__Item {
          grid-template-columns: 1rem 1fr;
          align-items: center;
        }

        .p-submenu-list #{$root}__Item {
          padding-left: v.$spacing;
        }

        #{$root}__ItemLabel {
          display: inherit;
        }

        #{$root}__Action {
          &:deep(.p-button-label) {
            display: inherit;
          }
        }
      }
    }
  }

  .p-panelmenu,
  .p-menu,
  .p-component.p-panelmenu,
  .p-component.p-menu {
    width: 100%;
    padding: 0;
    border: none;
    border-radius: 0;
    background-color: transparent;

    & .p-panelmenu-content {
      width: 100%;
      padding: 0;
      border: none;
      background-color: transparent;
    }

    & .p-submenu-list,
    & .p-panelmenu-panel {
      display: grid;
    }

    & .p-menuitem,
    & .p-panelmenu-header {
      display: inline-flex;
      width: 100%;
      font-weight: inherit;

      & #{$root}__Item,
      & #{$root}__Action {
        @include item;
      }
    }

    .p-submenu-list #{$root}__Item {
      padding-left: v.$spacing * 2;
    }
  }

  &__Item {
    @include item;

    display: grid;
    grid-template-columns: 1rem 1fr;
    grid-gap: v.$spacing-2;

    &:hover,
    &--active {
      &::before {
        content: '';
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        width: 4px;
        border-radius: 0 3px 3px 0;
        background: var(--primary-color);
      }
    }
  }

  & &__Action.p-button {
    @include item;

    border-radius: 0;

    &:focus,
    &:enabled:focus,
    &.p-button-secondary:enabled:focus {
      box-shadow: none;
    }
  }

  &__Spacer {
    @include m.mobile {
      flex-grow: 0;
      flex-basis: 0;
    }

    flex: 1 1 100px;
    width: 100%;
  }
}
</style>
